/*
 * MBIC_BootLoader.h
 *
 *  Created on: 2020. 5. 4.
 *      Author: parkyj
 */

#ifndef MBIC_BOOTLOADER_H_
#define MBIC_BOOTLOADER_H_


#define MBIC_PREAMBLE0 0x16
#define MBIC_PREAMBLE1 0x16
#define MBIC_PREAMBLE2 0x16
#define MBIC_PREAMBLE3 0x16
#define MBIC_SUBUID0 0x00
#define MBIC_SUBUID1 0xF1
#define MBIC_RCODE
#define MBIC_TRID
#define MBIC_SEQNUM
#define MBIC_TTL
#define MBIC_TIME
#define MBIC_ERRRESPONSE
#define MBIC_CMD
#define MBIC_LENGTH
#define MBIC_CHECKSHUM
#define MBIC_ETX 0x03

#define MBIC_HEADER_LENG 17

typedef enum{
    DOWNLOAD_NOTI_REQ = 0x10,
    DOWNLOAD_DATA,
    DOWNLOAD_CONFIRM,
    DOWNLOAD_COMPLETE_CMD,
    SYSTEMP_REBOOT,
};
typedef enum{
    MBIC_PREAMBLE_0 = 0,
    MBIC_PREAMBLE_1,
    MBIC_PREAMBLE_2,
    MBIC_PREAMBLE_3,
    MBIC_SUBUID_0, //4
    MBIC_SUBUID_1,
    MBIC_RCODE_0,
    MBIC_TRID_0,
    MBIC_TRID_1,
    MBIC_SEQSUM_0, // 9Index

    MBIC_TTL_0, //10 INDEX
    MBIC_TIME_0,
    MBIC_TIME_1,
    MBIC_TIME_2,
    MBIC_TIME_3,
    MBIC_TIME_4,
    MBIC_TIME_5,
    MBIC_ERRRESPONSE_0,
    MBIC_CMD_0,
    MBIC_LENGTH_0, // 19INDEX


    MBIC_LENGTH_1, // 20
    MBIC_HEADERCHECKSUM_0,
    MBIC_DOWNLOAD_MARK0,
    MBIC_DOWNLOAD_MARK1,
    MBIC_DOWNLOAD_MARK2,
    MBIC_DOWNLOAD_MARK3,
    MBIC_DOWNLOAD_MARK4,
    MBIC_DOWNLOAD_MARK5,
    MBIC_DOWNLOAD_MARK6,
    MBIC_DOWNLOAD_MARK7,
    MBIC_DOWNLOAD_MARK8,
    MBIC_DOWNLOAD_TYPE,
    MBIC_DOWNLOAD_FILETYPE,
    MBIC_DOWNLOAD_VERSION0,
    MBIC_DOWNLOAD_VERSION1,
    MBIC_DOWNLOAD_VERSION2,    
    MBIC_DOWNLOAD_FILENAME0,
    MBIC_DOWNLOAD_FILENAME1,
    MBIC_DOWNLOAD_FILENAME2,
    MBIC_DOWNLOAD_FILENAME3,
    MBIC_DOWNLOAD_FILENAME4,
    MBIC_DOWNLOAD_FILENAME5,
    MBIC_DOWNLOAD_FILENAME6,
    MBIC_DOWNLOAD_FILENAME7,
    MBIC_DOWNLOAD_FILENAME8,
    MBIC_DOWNLOAD_FILENAME9,
    MBIC_DOWNLOAD_FILENAME10,
    MBIC_DOWNLOAD_FILENAME11,
    MBIC_DOWNLOAD_FILENAME12,
    MBIC_DOWNLOAD_FILENAME13,
    MBIC_DOWNLOAD_FILENAME14,
    MBIC_DOWNLOAD_FILENAME15,
    MBIC_DOWNLOAD_FILENAME16,
    MBIC_DOWNLOAD_FILENAME17,
    MBIC_DOWNLOAD_FILENAME18,
    MBIC_DOWNLOAD_FILENAME19,
    MBIC_DOWNLOAD_FILENAME20,
    MBIC_DOWNLOAD_FILENAME21,
    MBIC_DOWNLOAD_FILENAME22,
    MBIC_DOWNLOAD_FILENAME23,
    MBIC_DOWNLOAD_FILENAME24,
    MBIC_DOWNLOAD_FILENAME25,
    MBIC_DOWNLOAD_FILENAME26,
    MBIC_DOWNLOAD_FILENAME27,
    MBIC_DOWNLOAD_FILENAME28,
    MBIC_DOWNLOAD_FILENAME29,
    MBIC_DOWNLOAD_FILENAME30,
    MBIC_DOWNLOAD_FILENAME31,
    MBIC_DOWNLOAD_FILENAME32,
    MBIC_DOWNLOAD_FILENAME33,
    MBIC_DOWNLOAD_FILENAME34,
    MBIC_DOWNLOAD_FILENAME35,
    MBIC_DOWNLOAD_FILENAME36,
    MBIC_DOWNLOAD_FILENAME37,
    MBIC_DOWNLOAD_FILENAME38,
    MBIC_DOWNLOAD_FILENAME39,
    MBIC_DOWNLOAD_FILENAME40,
    MBIC_DOWNLOAD_CREATION_TIME0,
    MBIC_DOWNLOAD_CREATION_TIME1,
    MBIC_DOWNLOAD_CREATION_TIME2,
    MBIC_DOWNLOAD_CREATION_TIME3,
    MBIC_DOWNLOAD_CREATION_TIME4,
    MBIC_DOWNLOAD_CREATION_TIME5,    
    MBIC_DOWNLOAD_LENGTH0,        
    MBIC_DOWNLOAD_LENGTH1,        
    MBIC_DOWNLOAD_LENGTH2,        
    MBIC_DOWNLOAD_LENGTH3,            
    MBIC_DOWNLOAD_CRC0,                
    MBIC_DOWNLOAD_CRC1,                
    MBIC_DOWNLOAD_CRC2,                
    MBIC_DOWNLOAD_CRC3,                    
    MBIC_DOWNLOAD_RESERVED0,
    MBIC_DOWNLOAD_RESERVED1,
    MBIC_DOWNLOAD_RESERVED2,
    MBIC_DOWNLOAD_RESERVED3,
    MBIC_DOWNLOAD_RESERVED4,
    MBIC_DOWNLOAD_RESERVED5,
    MBIC_DOWNLOAD_RESERVED6,
    MBIC_DOWNLOAD_RESERVED7,
    MBIC_DOWNLOAD_RESERVED8,
    MBIC_DOWNLOAD_RESERVED9,
    MBIC_DOWNLOAD_RESERVED10,
    MBIC_DOWNLOAD_RESERVED11,
    MBIC_DOWNLOAD_RESERVED12,
    MBIC_DOWNLOAD_RESERVED13,
    MBIC_DOWNLOAD_RESERVED14,
    MBIC_DOWNLOAD_RESERVED15,
    MBIC_DOWNLOAD_RESERVED16,
    MBIC_DOWNLOAD_RESERVED17,
    MBIC_DOWNLOAD_RESERVED18,
    MBIC_DOWNLOAD_RESERVED19,
    MBIC_DOWNLOAD_RESERVED20,
    MBIC_DOWNLOAD_RESERVED21,
    MBIC_DOWNLOAD_RESERVED22,
    MBIC_DOWNLOAD_RESERVED23,
    MBIC_DOWNLOAD_RESERVED24,
    MBIC_DOWNLOAD_RESERVED25,
    MBIC_DOWNLOAD_RESERVED26,
    MBIC_DOWNLOAD_RESERVED27,
    MBIC_DOWNLOAD_RESERVED28,
    MBIC_DOWNLOAD_RESERVED29,
    MBIC_DOWNLOAD_RESERVED30,
    MBIC_DOWNLOAD_RESERVED31,
    MBIC_DOWNLOAD_RESERVED32,
    MBIC_DOWNLOAD_RESERVED33,
    MBIC_DOWNLOAD_RESERVED34,
    MBIC_DOWNLOAD_RESERVED35,
    MBIC_DOWNLOAD_RESERVED36,
    MBIC_DOWNLOAD_RESERVED37,
    MBIC_DOWNLOAD_RESERVED38,
    MBIC_DOWNLOAD_RESERVED39,
    MBIC_DOWNLOAD_RESERVED40,
    MBIC_DOWNLOAD_RESERVED41,
    MBIC_DOWNLOAD_RESERVED42,
    MBIC_DOWNLOAD_RESERVED43,
    MBIC_DOWNLOAD_RESERVED44,
    MBIC_DOWNLOAD_RESERVED45,
    MBIC_DOWNLOAD_RESERVED46,
    MBIC_DOWNLOAD_RESERVED47,
    MBIC_DOWNLOAD_RESERVED48,
    MBIC_DOWNLOAD_RESERVED49,
    MBIC_DOWNLOAD_RESERVED50,
    MBIC_DOWNLOAD_RESERVED51,
    MBIC_DOWNLOAD_RESERVED52,
    MBIC_DOWNLOAD_RESERVED53,
    MBIC_DOWNLOAD_RESERVED54,
    MBIC_DOWNLOAD_RESERVED55,
    MBIC_DOWNLOAD_RESERVED56,
    MBIC_DOWNLOAD_RESERVED57,
    MBIC_DOWNLOAD_RESERVED58,
    MBIC_DOWNLOAD_DATASTART,    

/*
 * PayLoadSTART
 */
}MBICProt_st;

#endif /* MBIC_BOOTLOADER_H_ */
